/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.workingbriefcase.vista.administrador;

import com.workingbriefcase.persistencia.controladores.CargoJpaController;
import com.workingbriefcase.persistencia.entities.Cargo;
import com.workingbriefcase.utilidades.MetodosUtil;
import java.util.List;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;

/**
 * Nombre de la clase: FrmCargo
 * Fecha: 07/11/2019
 * Copyright: EnclaveStudio
 * @author Oscar Caceres
 */
public class FrmCargo extends javax.swing.JInternalFrame {
     
     CargoJpaController cc = new CargoJpaController();
     MetodosUtil mu = new MetodosUtil();
            int codigo = 0;
    /**
     * Creates new form FrmCargo
     */
    public FrmCargo() {
        initComponents();
        llenarTabla();
    }
     boolean cajasVacias(){
         boolean estado  = true;
         if(txtNombre.getText().isEmpty()){
             estado = false;
         }
         return estado;
     }
     Cargo llenar(){
              Cargo c = new Cargo();
              c.setId(codigo);
              c.setNombre(txtNombre.getText());
              c.setBorrado(true);
              return c;
     }
     
     void llenarTabla(){
         String[] headers = {"Codigo","Nombre"};
         DefaultTableModel modelo = new DefaultTableModel(null, headers);
         Cargo car = new Cargo();
         Object[] obj = new Object[2];
         try {
             List<Cargo> lista = cc.findCargoEntities();
             for (int i = 0; i < lista.size(); i++) {
                 car = (Cargo)lista.get(i);
                 obj[0] = car.getId();
                 obj[1] = car.getNombre();
                 modelo.addRow(obj);
             }
             this.jtablaDatos.setModel(modelo);
         } catch (Exception e) {
             JOptionPane.showMessageDialog(null, "Error al mostrar los datos. " + e.toString());
         }
     }
    void limpiar(){
        txtNombre.setText("");
    }
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        txtNombre = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        jtablaDatos = new javax.swing.JTable();
        btnInsertar = new javax.swing.JButton();
        btnModificar = new javax.swing.JButton();
        btnEliminar = new javax.swing.JButton();
        btnCancelar = new javax.swing.JButton();

        setClosable(true);

        jLabel1.setText("CARGO");

        jLabel2.setText("Nombre:");

        txtNombre.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                txtNombreKeyTyped(evt);
            }
        });

        jtablaDatos.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jtablaDatos.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jtablaDatosMouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(jtablaDatos);

        btnInsertar.setText("Insertar");
        btnInsertar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnInsertarActionPerformed(evt);
            }
        });

        btnModificar.setText("Modificar");
        btnModificar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnModificarActionPerformed(evt);
            }
        });

        btnEliminar.setText("Eliminar");
        btnEliminar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnEliminarActionPerformed(evt);
            }
        });

        btnCancelar.setText("Cancelar");
        btnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 453, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(47, 47, 47)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(btnInsertar)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(btnModificar)
                                .addGap(18, 18, 18)
                                .addComponent(btnEliminar)
                                .addGap(18, 18, 18)
                                .addComponent(btnCancelar))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(35, 35, 35)
                                .addComponent(jLabel2)
                                .addGap(30, 30, 30)
                                .addComponent(txtNombre, javax.swing.GroupLayout.PREFERRED_SIZE, 237, javax.swing.GroupLayout.PREFERRED_SIZE))))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(210, 210, 210)
                        .addComponent(jLabel1)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(34, 34, 34)
                .addComponent(jLabel1)
                .addGap(27, 27, 27)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(txtNombre, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnInsertar)
                    .addComponent(btnModificar)
                    .addComponent(btnEliminar)
                    .addComponent(btnCancelar))
                .addGap(18, 18, 18)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 140, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnInsertarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnInsertarActionPerformed
        try {
            if(cajasVacias()){
                    cc.create(llenar());
              JOptionPane.showMessageDialog(null,"Datos ingresados correctamente.");
              llenarTabla();
              limpiar();
            }else{
                JOptionPane.showMessageDialog(null, "Debe todos llenar los campos.");
            }
        
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null,"Error al ingresar los datos." + e.toString());
        }
    }//GEN-LAST:event_btnInsertarActionPerformed

    private void btnModificarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnModificarActionPerformed
        // TODO add your handling code here:
           try {
               if(cajasVacias()){
                    if(JOptionPane.showConfirmDialog(null, "Desea modificar los datos?","Modificar",JOptionPane.YES_NO_OPTION) == 0){
                     cc.edit(llenar());
                    JOptionPane.showMessageDialog(null,"Datos modificados correctamente.");
                      llenarTabla();
                      limpiar();
               }
               }else{
                JOptionPane.showMessageDialog(null, "Debe todos llenar los campos.");
            }
              
          
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null,"Error al modificar los datos." + e.toString());
        }
    }//GEN-LAST:event_btnModificarActionPerformed

    private void txtNombreKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtNombreKeyTyped
        mu.soloLetras(evt);
    }//GEN-LAST:event_txtNombreKeyTyped

    private void btnEliminarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnEliminarActionPerformed
           try {
               if(cajasVacias())
               if(JOptionPane.showConfirmDialog(null, "Desea eliminar los datos?","Modificar",JOptionPane.YES_NO_OPTION) == 0){
                     cc.destroy(llenar().getId());
                    JOptionPane.showMessageDialog(null,"Datos eliminar correctamente.");
                   llenarTabla();
                   limpiar();
               }
               else
                   JOptionPane.showMessageDialog(null, "Debe seleccionar un registro.");
          
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null,"Error al eliminar los datos." + e.toString());
        }
    }//GEN-LAST:event_btnEliminarActionPerformed

    private void jtablaDatosMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jtablaDatosMouseClicked
        int fila = jtablaDatos.getSelectedRow();
        codigo = Integer.parseInt(String.valueOf(this.jtablaDatos.getValueAt(fila, 0)));
        txtNombre.setText(String.valueOf(this.jtablaDatos.getValueAt(fila, 1)));
    }//GEN-LAST:event_jtablaDatosMouseClicked

    private void btnCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelarActionPerformed
       if(JOptionPane.showConfirmDialog(null, "Desea cancelar la operacion?","Cancelar",JOptionPane.YES_NO_OPTION)==0){
           limpiar();
       }
    }//GEN-LAST:event_btnCancelarActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancelar;
    private javax.swing.JButton btnEliminar;
    private javax.swing.JButton btnInsertar;
    private javax.swing.JButton btnModificar;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jtablaDatos;
    private javax.swing.JTextField txtNombre;
    // End of variables declaration//GEN-END:variables
}
